<template>
  <Row class="investor-stock-compare">
    <i-col v-for="(stockCode, index) in stockCodeList" :key="index"
           class="content-block" :lg="12" :md="12" :sm="24" :xs="24"
           @click.native="displaySettingOptionAction(stockCode, true)">
      <stock-tech-charts v-if="stockDataDict[stockCode]"
                         :id="stockCode"
                         :stock-code="stockCode"
                         :data="stockDataDict[stockCode]"
                         :chart-types="stockChartOptions[stockCode]['chartTypes']"
                         :sync-point="syncPoint"
                         :load-more-data-args="loadMoreDataArgs"
                         :kd-options="stockChartOptions[stockCode]['kdOptions']"
                         :vol-options="stockChartOptions[stockCode]['volOptions']"
                         :macd-options="stockChartOptions[stockCode]['macdOptions']"
                         :kd933-options="stockChartOptions[stockCode]['kd933Options']"
                         @on-point="broadcastPointAction"
                         @on-load-more-data="broadcastLoadMoreDataArgsAction">
      </stock-tech-charts>
    </i-col>
  </Row>
</template>

<script>
import StockTechCharts from '../../../components/p5/StockTechCharts'
import { validators as api } from '../../../configs/request-validator/stock-data';

const actions = {
  broadcastPointAction(point) {
    this.syncPoint = point;
  },
  broadcastLoadMoreDataArgsAction(args) {
    this.loadMoreDataArgs = {...args, flag: (new Date()).getTime()};
  },
  displaySettingOptionAction(stockCode, forceHidden = false) {
    const toHide = this.stockChartOptions[stockCode]['display'] || forceHidden;
    if (toHide) {
      this.stockChartOptions[stockCode]['opacity'] = 0;
      setTimeout(() => {
        this.stockChartOptions[stockCode]['display'] = false;
      }, 10);

    } else {
      this.stockChartOptions[stockCode]['display'] = true;
      setTimeout(() => {
        this.stockChartOptions[stockCode]['opacity'] = 1;
      }, 1);
    }
  }
};

export default {
  name: 'index',
  components: { StockTechCharts },
  data() {
    return {
      stockDataDict: undefined,
      // chart
      syncPoint: undefined,
      loadMoreDataArgs: undefined,
      stockChartOptions: {},
    };
  },
  methods: {
    ...actions,
  },
  mounted() {
    this.$displayBodyBlock(false);
  },
  async asyncData({app, route}) {
    let stockDataDict = undefined;
    let stockChartOptions = {};
    const stockCodes = route.query['code'].split('-');

    // request
    const stockDataRequest = {
      stockCodes,
      startFrom: null,
      endAt: null,
    };
    // invoke api
    try {
      const apiResponse = await Promise.all([
        app.$api(api.AccessByStockCodeRequest, stockDataRequest, undefined, false),
      ]);
      // set vue data
      stockDataDict = apiResponse[0]['data'];
      stockCodes.forEach((stockCode) => {
        stockChartOptions[stockCode] = {
          chartTypes: [ 'kd' ],
          kdOptions: { height: '350px' },
          volOptions: { height: '250px' },
          macdOptions: { height: '250px' },
          kd933Options: { height: '250px' },
          display: false,
          opacity: 0,
        };
      });
    } catch (error) {
      app.$apiErrorHandler(error);
    }
    return {
      stockDataDict,
      stockChartOptions,
      stockCodeList: stockCodes,
    };
  },
}
</script>

<style lang="scss" scoped>
  @import "../../../assets/css/mixin";

  .investor-stock-compare {
    height: 100%;
    text-align: center;
    .content-block {
      max-height: 100%;
      overflow-y: auto;
      overflow-x: hidden;
      padding: 30px 10px;
    }
  }
</style>
